2012-08-23 132 views
0

我正在製作一個專用於啓動/停止/重新啓動獨角獸的獨角獸外殼腳本。如何讓它實際工作有點麻煩。找不到shell腳本命令

任何幫助,這是非常感謝。

當我運行shell腳本(sh unicorn_init.sh)時,我得到以下輸出。

kill: 72: No such process 

    unicorn_init.sh: 72: cd /data/appname/staging/releases/20120823055753; bundle exec unicorn_rails -D -c /data/appname/staging/releases/20120823055753/config/unicorn.rb -E staging: not found 

這是我的shell腳本的當前版本:

#!/bin/sh 
set -e 
# Example init script, this can be used with nginx, too, 
# since nginx and unicorn accept the same signals 

# Feel free to change any of the following variables for your app: 
TIMEOUT=${TIMEOUT-60} 
APP_ROOT=/data/appname/staging/releases/20120823055753 
SHARED_ROOT=/data/appname/staging/shared 
PID=$SHARED_ROOT/pids/unicorn-staging.pid 
CMD="cd $APP_ROOT; bundle exec unicorn_rails -D -c $APP_ROOT/config/unicorn.rb -E staging" 
action="$1" 
set -u 

old_pid="$PID.oldbin" 

cd $APP_ROOT || exit 1 

sig() { 
     test -s "$PID" && kill -$1 `cat $PID` 
} 

oldsig() { 
     test -s $old_pid && kill -$1 `cat $old_pid` 
} 

case $action in 
start) 
     sig 0 && echo >&2 "Already running" && exit 0 
     "$CMD" 
     ;; 
stop) 
     sig QUIT && exit 0 
     echo >&2 "Not running" 
     ;; 
force-stop) 
     sig TERM && exit 0 
     echo >&2 "Not running" 
     ;; 
restart|reload) 
     sig HUP && echo reloaded OK && exit 0 
     echo >&2 "Couldn't reload, starting '$CMD' instead" 
     "$CMD" 
     ;; 
upgrade) 
     if sig USR2 && sleep 2 && sig 0 && oldsig QUIT 
     then 
       n=$TIMEOUT 
       while test -s $old_pid && test $n -ge 0 
       do 
         printf '.' && sleep 1 && n=$(($n - 1)) 
       done 
       echo 

       if test $n -lt 0 && test -s $old_pid 
       then 
         echo >&2 "$old_pid still exists after $TIMEOUT seconds" 
         exit 1 
       fi 
       exit 0 
     fi 
     echo >&2 "Couldn't upgrade, starting '$CMD' instead" 
     "$CMD" 
     ;; 
reopen-logs) 
     sig USR1 
     ;; 
*) 
     echo >&2 "Usage: $0 <start|stop|restart|upgrade|force-stop|reopen-logs>" 
     exit 1 
     ;; 
esac 
+0

通過快速瀏覽,則需要修改'sig'(1)不從'kill'顯示錯誤輸出,如果過程不存在,和(2)不死。由於'set -e',如果你試圖終止一個不再運行的進程,你的腳本將會終止。這不難解決,但編寫'set -e'則更具挑戰性。 – tripleee

+0

刪除'「$ CMD」'附近的引號 – cdarke

回答

2

的引號$CMD意味着整個變量的值是一個命令,包括嵌入的空格。下面是一個簡單的例子來說明:

/home/user1> CMD='echo hello' 
/home/user1> $CMD 
hello 
/home/user1> "$CMD" 
-bash: echo hello: command not found 
/home/user1>